define([
    'react/addons',
    'lodash'
], function (React, _) {
    'use strict';
    function mergeProps(inline, external) {
        var res = _.assign({}, inline, external);
        if (inline.hasOwnProperty('style')) {
            res.style = _.defaults(res.style, inline.style);
        }
        if (inline.hasOwnProperty('className') && external.hasOwnProperty('className')) {
            res.className = external.className + ' ' + inline.className;
        }
        return res;
    }
    return function () {
        return React.createElement('input', mergeProps({
            'style': {
                height: '10px',
                width: '3px'
            },
            'className': 'clsA'
        }, {
            style: { width: '5px' },
            type: 'text',
            className: 'clsB'
        }));
    };
});