define([
    'react/addons',
    'lodash'
], function (React, _) {
    'use strict';
    function mergeProps(inline, external) {
        var res = _.assign({}, inline, external);
        if (inline.hasOwnProperty('style')) {
            res.style = _.defaults(res.style, inline.style);
        }
        if (inline.hasOwnProperty('className') && external.hasOwnProperty('className')) {
            res.className = external.className + ' ' + inline.className;
        }
        return res;
    }
    function scopeI2() {
        var i = 'test';
        return React.createElement('input', mergeProps({
            'alt': 'test rt-props',
            'style': {
                height: '10px',
                width: '3px'
            }
        }, {
            style: { width: '5px' },
            type: 'text',
            value: i
        }));
    }
    return function () {
        return scopeI2.apply(this, []);
    };
});