'use strict';

var test = require('tape');
var reactTemplates = require('../../src/reactTemplates');
var fs = require('fs');
var util = require('./util');

test('html tests', function (t) {
    var files = ['scope-evaluated-after-repeat.rt'];
    t.plan(files.length);

    files.forEach(check);

    function check(testFile) {
        var filename = util.joinDataPath(testFile);
        var code = '';
        try {
            var html = util.readFile(filename);
            var expected = util.readFileNormalized(filename + '.html');
            code = reactTemplates.convertTemplateToReact(html).replace(/\r/g, '');
            var actual = util.codeToHtml(code);
            actual = util.normalizeHtml(actual);
            expected = util.normalizeHtml(expected);
            var equal = util.compareAndWrite(t, actual, expected, filename);
            if (!equal) {
                fs.writeFileSync(filename + '.code.js', code);
            }
        } catch (e) {
            console.log(testFile, e);
            fs.writeFileSync(filename + '.code.js', code);
        }
    }
});