'use strict';

var test = require('tape');
var _ = require('lodash');
var stringUtils = require('../../src/stringUtils');

test('html tests', function (t) {
    var res = handleStyleProp(' font-size :  14px ; color:pink;');
    t.equal(res, '{fontSize : 14px,color : pink}');
    t.end();
});

function handleStyleProp(val) {
    //_.chain('a;b;c').trim().split(';').value()
    var styleStr = _(val.trim()).split(';').map(_.trim).filter(function (i) {
        return i && i.indexOf(':') !== -1;
    }).map(function (i) {
        var pair = i.split(':');
        var val = pair.slice(1).join(':').trim();
        return stringUtils.convertToCamelCase(pair[0].trim()) + ' : ' + val.trim();
    }).join(',');
    return '{' + styleStr + '}';
}