#lodash
------------------------------

```javascript
childrenIds = _(children).map(function(comp){return comp.id;}).value();

=>

childrenIds = _.map(children, 'id’);

```

------------------------------

```
var indexToInsertBefore = -1;
                                _.each(children, function (child, childIndex) {
                                    var refName = child.props.refInParent;
                                    if (refName && refName === refVal[1]) {
                                        indexToInsertBefore = childIndex;
                                        return false; // found - stop
                                    }
                                    return true; // continue
                                });
=>

var indexToInsertBefore = _.findIndex(children, {props: {refInParent: refVal[1]}});
```

------------------------------

functionLibrary

```
_(obj).keys().forEach(obj, function (key) {
    var item = obj[key];
    //code...
});

=>

_.forEach(obj, function (item, key) {
    //code...
})
```
------------------------------
```
return _.filter(_.filter(_.flatten(skinTree), function (item) {
    return _.isString(item);
}), function (item, index) {
    return (index % 2 !== 0);
});

=> ??? (not checked)

_(skinTree).flatten().filter(_.isString).filter(function(item, index) {
    return index % 2 !== 0
}).value();
```
------------------------------
```
return _.zipObject(_.map(_.compact(rule.split(';')), function(singleRule){
    return singleRule.split(':');
}));

=>

            return _(rule)
                .split(';')
                .compact()
                .invoke('split', ':')
                .zipObject()
                .value();
```
------------------------------

```
_(pageJson.data.document_data)
    .filter(function isAppPart(component) {
        return appPartMediaInnerCustomizationFormatFixer.isAppPartType(component.type);
    })
    .forEach(function (appPart) {
        _(appPart.appLogicCustomizations)
            .compact()
            .groupBy('view')
            .filter(function isMediaInnerView(ignoredCustomizations, view) {
                return appPartMediaInnerViewNameUtils.isMediaInnerViewName(view);
            })
            .forEach(function (mediaInnerCustomizations) {
                _(mediaInnerCustomizations)
                    .groupBy('fieldId')
                    .filter(function hasOnlyDesktopCustomizations(customizations) {
                        return _.isEqual(_.pluck(customizations, 'format'), ['']);
                    })
                    .forEach(function (desktopCustomizations) {
                        _.forEach(desktopCustomizations, function (customization) {
                            customization.format = '*';
                        });
                    })
                    .value();
            })
            .value();
    })
    .value();
```

---------------------------------------------------------

```
var sum = 0;
_.map(val, function (item) {
   sum += Math.abs(parseInt(this.getParamFromDefaultSkin(item).value, 10));
}.bind(this));
return sum;
```


---------------------------------------------------------
```
var counter = 0;
return _.reduce(getSiteMenu(siteData), function (res, item) {
   if (item.isVisible) {
       res.push(counter.toString());
       counter++;
   }
   return res;
}, []);

var count = _(menus)
    .filter('isVisible')
    .map(function (a,b) { return b.toString() })
    .value()
```
-----------------------------	

```
return _.reduce(widths, function (a, b) {
   return a < b ? a : b;
});
```

```
var total = _.reduce(widths, function (a, b) {
   return a + b;
}, 0);
```


```
_.map(widths, function (wdth, index) {
   if (index <= remnant - 1) {
       stretchItemsWidths[index]++;
   }
});

```


#### eslint rules

- map without return => forEach
- map/forEach w/o args => ?
- collection function w/o args => times?
- _(obj).keys().forEach(obj, function (key) {

```
widths = _.map(widths, function () {
   return maxWidth;
});

_.fill(widths, maxWidth);
```

prefer fill

- prefer _.constant(3) => function () { return null; }
- prefer _.constant(3) => () => 3
- prefer _.noop => function () {}


```
return _.reduce(existingComponents, function collectCompsThatAreUnderXY(result, comp) {
	if (isWithinComponentBounds(x, y, comp.layout)) {
		result.push(comp);
    }
	return result;
}, [], this);
```

- prefer _.last / first
	arr[arr.length-1]






```
pageIds = _.keys(mobileCompsMap);

for (var i = 0; i < pageIds.length; i++){
   var currPageId = pageIds[i];

   pagePointer = ps.pointers.components.getPage(currPageId, constants.VIEW_MODES.MOBILE);
   dal.set(ps.pointers.getInnerPointer(pagePointer, 'mobileComponents'), mobileCompsMap[currPageId]);
}
```


### Best practices

- Avoid for each, it has side effects by definition.
- Avoid reduce, to general purpose, try to be more specific.


```
var res = _.reduce(attrObj, function (result, value, key) {
   result.push({ name: key, value: value });
   return result;
}, [])

_.map(attrObj, function (v, k) { return {name: k, value: v}; })
```

__________________________________

```
return _(currentPagesData).omit('masterPage').mapValues(function (page, pageId) {
   if (!_.isEqual(page.structure, lastPagesData[pageId] && lastPagesData[pageId].structure)) {
       return page.structure;
   }
}).values().compact().value();
```

