'use strict';
//var webpack = require('webpack');
//var WebpackDevServer = require('webpack-dev-server');
//var config = require('./webpack.config');
//
//new WebpackDevServer(webpack(config), {
//    publicPath: config.output.publicPath,
//    hot: true,
//    historyApiFallback: true
//}).listen(3000, 'localhost', function (err, result) {
//        if (err) {
//            console.log(err);
//        }
//        console.log('Listening at localhost:3000');
//    });

var path = require('path');
var express = require('express');
var webpack = require('webpack');
var config = require('./webpack.config');

var app = express();
var compiler = webpack(config);

app.use(require('webpack-dev-middleware')(compiler, {
    noInfo: true,
    publicPath: config.output.publicPath
}));

app.use(require('webpack-hot-middleware')(compiler));

app.get('/', function(req, res) {
    res.sendFile(path.join(__dirname, 'index.html'));
});

app.use('/src', express.static('src'));
app.use('/libs', express.static('libs'));
app.use('/css', express.static('css'));
app.use('/dist', express.static('dist'));

app.listen(3000, 'localhost', function(err) {
    if (err) {
        console.log(err);
        return;
    }

    console.log('Listening at http://localhost:3000');
});
