define(['lodash', 'react', './examples.rt',
        'raw!../samples/hello.code', 'raw!../samples/hello.rt',
        'raw!../samples/todo.code', 'raw!../samples/todo.rt',
        'raw!../samples/rt-if.code', 'raw!../samples/rt-if.rt',
        'raw!../samples/rt-props.code', 'raw!../samples/rt-props.rt',
        'raw!../samples/rt-repeat.code', 'raw!../samples/rt-repeat.rt',
        'raw!../samples/weather.code', 'raw!../samples/weather.rt',
        'raw!../samples/rt-require.rt'
], function (_, React, examplesTemplate, helloCode, helloRT, todoCode, todoRT, rtIfCode, rtIfRT, rtPropsCode, rtPropsRT, rtRepeatCode, rtRepeatRT, weatherCode, weatherRT, rtRequireRT) {
    'use strict';

    var LinkedStateMixin = require('react-addons-linked-state-mixin');

    var samples = {
        hello: [helloCode, helloRT],
        todo: [todoCode, todoRT],
        props: [rtPropsCode, rtPropsRT],
        rtIf: [rtIfCode, rtIfRT],
        repeat: [rtRepeatCode, rtRepeatRT],
        weather: [weatherCode, weatherRT]
    };
    //samples = _.map(samples, function (v, k) {
    //    return {name: k, templateProps: _.template(v[0])({name: k}), templateHTML: v[1]};
    //});
    _.forEach(samples, function (v, k) {
        samples[k] = {name: k, templateProps: _.template(v[0])({name: k}), templateHTML: v[1]};
    });

    return React.createClass({
        displayName: 'Examples',
        mixins: [LinkedStateMixin],
        getInitialState: function () {
            var codeAmd = window.reactTemplates.convertTemplateToReact(rtRequireRT, {modules: 'amd', name: 'template'});
            var codeCJS = window.reactTemplates.convertTemplateToReact(rtRequireRT, {modules: 'commonjs', name: 'template'});
            var codeES6 = window.reactTemplates.convertTemplateToReact(rtRequireRT, {modules: 'es6', name: 'template'});
            return {
                rtRequire: {value: rtRequireRT},
                amd: {value: codeAmd},
                cjs: {value: codeCJS},
                es6: {value: codeES6},
                samples: samples
            };
        },
        render: examplesTemplate
    });
});
