'use strict';
var path = require('path');
var webpack = require('webpack');

module.exports = {
    context: __dirname,
    entry: {
        rtBrowser: ['./src/rt-main.js']
    },
    output: {
        filename: '[name].js',
        path: path.join(__dirname, 'dist'),
        publicPath: '/static/',
        // export itself to a global var
        libraryTarget: 'var',
        // name of the global var: "Foo"
        library: 'reactTemplates'
    },
    plugins: [],
    externals: {
        // require("jquery") is external and available on the global var jQuery
        lodash: '_'
    },
    resolve: {
        // you can now require('file') instead of require('file.coffee')
        extensions: ['', '.js', '.json']
    },
    module: {
        loaders: [
            {test: /\.js$/, exclude: /node_modules/, loaders: ['babel']},
            {test: /\.json$/, loader: 'json'}
        ]
    }
};
